(* This file is automatically generated from the OCaml source file
<repository_root>/ml_sources/aneris_lang/lib/queue_code.ml *)

From aneris.aneris_lang Require Import ast.
From aneris.aneris_lang.lib Require Import list_code.

Definition queue_empty : val := λ: <>, ([], []).

Definition queue_is_empty : val :=
  λ: "q",
  match: Fst "q" with
    SOME "_p" => #false
  | NONE => match: Snd "q" with
        SOME "_p" => #false
      | NONE => #true
      end
  end.

Definition queue_add : val := λ: "e" "q", (Fst "q", "e" :: Snd "q").

Definition queue_norm : val :=
  λ: "q",
  match: Fst "q" with
    SOME "_p" => "q"
  | NONE => (list_rev (Snd "q"), [])
  end.

Definition queue_peek_opt : val :=
  λ: "q",
  let: "q'" := queue_norm "q" in
  match: Fst "q'" with
    SOME "p" => SOME (Fst "p")
  | NONE => NONE
  end.

Definition queue_take_opt : val :=
  λ: "q",
  let: "q'" := queue_norm "q" in
  match: Fst "q'" with
    SOME "p" => SOME ((Fst "p"), ((Snd "p"), (Snd "q'")))
  | NONE => NONE
  end.

Definition queue_filter : val :=
  λ: "pred" "q",
  let: "head" := Fst "q" in
  let: "rev" := Snd "q" in
  let: "all" := list_append "head" (list_rev "rev") in
  (list_filter "pred" "all", NONE).

Definition queue_drop : val :=
  rec: "queue_drop" "q" "n" :=
  (if: "n" = #0
   then  "q"
   else
     let: "q'" := queue_norm "q" in
     match: Fst "q'" with
       SOME "p" => "queue_drop" ((Snd "p"), (Snd "q'")) ("n" - #1)
     | NONE => "q'"
     end).

Definition queue_iter : val :=
  λ: "f" "q", list_iter "f" (Fst "q");;
               list_iter "f" (list_rev (Snd "q")).

Definition queue_iteri : val :=
  λ: "f" "q",
  list_iteri "f" (Fst "q");;
  list_iteri_loop "f" (list_length (Fst "q")) (list_rev (Snd "q")).
